Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1321)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! some REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -259,5 +259,5 @@
     IF ( coupling_mode /= 'uncoupled')  THEN
 
-       IF ( dt_coupling == 9999999.9 )  THEN
+       IF ( dt_coupling == 9999999.9_wp )  THEN
           message_string = 'dt_coupling is not set but required for coup' // &
                            'ling mode "' //  TRIM( coupling_mode ) // '"'
@@ -920,5 +920,5 @@
 !
 !--    In case of no given gradients for ug, choose a zero gradient
-       IF ( ug_vertical_gradient_level(1) == -9999999.9 )  THEN
+       IF ( ug_vertical_gradient_level(1) == -9999999.9_wp )  THEN
           ug_vertical_gradient_level(1) = 0.0
        ENDIF  
@@ -984,5 +984,5 @@
 !
 !--    In case of no given gradients for vg, choose a zero gradient
-       IF ( vg_vertical_gradient_level(1) == -9999999.9 )  THEN
+       IF ( vg_vertical_gradient_level(1) == -9999999.9_wp )  THEN
           vg_vertical_gradient_level(1) = 0.0
        ENDIF
@@ -991,5 +991,5 @@
 !--    Let the initial wind profiles be the calculated ug/vg profiles or
 !--    interpolate them from wind profile data (if given)
-       IF ( u_profile(1) == 9999999.9  .AND.  v_profile(1) == 9999999.9 )  THEN
+       IF ( u_profile(1) == 9999999.9_wp  .AND.  v_profile(1) == 9999999.9_wp )  THEN
 
           u_init = ug
@@ -1018,5 +1018,5 @@
              ENDIF
 
-             IF ( kk < 100 .AND. uv_heights(kk+1) /= 9999999.9 )  THEN
+             IF ( kk < 100 .AND. uv_heights(kk+1) /= 9999999.9_wp )  THEN
                 u_init(k) = u_profile(kk) + ( zu(k) - uv_heights(kk) ) /       &
                                        ( uv_heights(kk+1) - uv_heights(kk) ) * &
@@ -1100,5 +1100,5 @@
 !--    In case of no given temperature gradients, choose gradient of neutral
 !--    stratification
-       IF ( pt_vertical_gradient_level(1) == -9999999.9 )  THEN
+       IF ( pt_vertical_gradient_level(1) == -9999999.9_wp )  THEN
           pt_vertical_gradient_level(1) = 0.0
        ENDIF
@@ -1236,5 +1236,5 @@
 !--       In case of no given leaf area density gradients, choose a vanishing
 !--       gradient
-          IF ( lad_vertical_gradient_level(1) == -9999999.9 ) THEN
+          IF ( lad_vertical_gradient_level(1) == -9999999.9_wp ) THEN
              lad_vertical_gradient_level(1) = 0.0
           ENDIF
@@ -1247,5 +1247,5 @@
 !-- Initialize large scale subsidence if required
     If ( large_scale_subsidence )  THEN
-       IF ( subs_vertical_gradient_level(1) /= -9999999.9 .AND. &
+       IF ( subs_vertical_gradient_level(1) /= -9999999.9_wp .AND. &
                                      .NOT. large_scale_forcing )  THEN
           CALL init_w_subsidence
@@ -1255,5 +1255,5 @@
 !--    are read in from file LSF_DATA
 
-       IF ( subs_vertical_gradient_level(1) == -9999999.9 .AND. &
+       IF ( subs_vertical_gradient_level(1) == -9999999.9_wp .AND. &
                                      .NOT. large_scale_forcing )  THEN
           message_string = 'There is no default large scale vertical ' // &
@@ -1264,5 +1264,5 @@
        ENDIF
     ELSE
-        IF ( subs_vertical_gradient_level(1) /= -9999999.9 )  THEN
+        IF ( subs_vertical_gradient_level(1) /= -9999999.9_wp )  THEN
            message_string = 'Enable usage of large scale subsidence by ' // &
                             'setting large_scale_subsidence = .T..'
@@ -1284,5 +1284,5 @@
     ELSEIF ( reference_state == 'single_value' )  THEN
        use_single_reference_value = .TRUE.
-       IF ( pt_reference == 9999999.9 )  pt_reference = pt_surface
+       IF ( pt_reference == 9999999.9_wp )  pt_reference = pt_surface
        vpt_reference = pt_reference * ( 1.0 + 0.61 * q_surface )
     ELSE
@@ -1528,5 +1528,5 @@
     ENDIF
 
-    IF ( surface_heatflux == 9999999.9  )  THEN
+    IF ( surface_heatflux == 9999999.9_wp  )  THEN
        constant_heatflux = .FALSE.
        IF ( large_scale_forcing )  THEN
@@ -1548,9 +1548,9 @@
     ENDIF
 
-    IF ( top_heatflux     == 9999999.9 )  constant_top_heatflux = .FALSE.
+    IF ( top_heatflux     == 9999999.9_wp )  constant_top_heatflux = .FALSE.
 
     IF ( neutral )  THEN
 
-       IF ( surface_heatflux /= 0.0  .AND.  surface_heatflux /= 9999999.9 ) &
+       IF ( surface_heatflux /= 0.0  .AND.  surface_heatflux /= 9999999.9_wp ) &
        THEN
           message_string = 'heatflux must not be set for pure neutral flow'
@@ -1558,5 +1558,5 @@
        ENDIF
 
-       IF ( top_heatflux /= 0.0  .AND.  top_heatflux /= 9999999.9 ) &
+       IF ( top_heatflux /= 0.0  .AND.  top_heatflux /= 9999999.9_wp ) &
        THEN
           message_string = 'heatflux must not be set for pure neutral flow'
@@ -1566,9 +1566,9 @@
     ENDIF
 
-    IF ( top_momentumflux_u /= 9999999.9  .AND.  &
-         top_momentumflux_v /= 9999999.9 )  THEN
+    IF ( top_momentumflux_u /= 9999999.9_wp  .AND.  &
+         top_momentumflux_v /= 9999999.9_wp )  THEN
        constant_top_momentumflux = .TRUE.
-    ELSEIF (  .NOT. ( top_momentumflux_u == 9999999.9  .AND.  &
-           top_momentumflux_v == 9999999.9 ) )  THEN
+    ELSEIF (  .NOT. ( top_momentumflux_u == 9999999.9_wp  .AND.  &
+           top_momentumflux_v == 9999999.9_wp ) )  THEN
        message_string = 'both, top_momentumflux_u AND top_momentumflux_v ' // &
                         'must be set'
@@ -1617,6 +1617,6 @@
        ENDIF
 
-       IF ( top_salinityflux == 9999999.9 )  constant_top_salinityflux = .FALSE.
-       IF ( ibc_sa_t == 1  .AND.   top_salinityflux == 9999999.9 )  THEN
+       IF ( top_salinityflux == 9999999.9_wp )  constant_top_salinityflux = .FALSE.
+       IF ( ibc_sa_t == 1  .AND.   top_salinityflux == 9999999.9_wp )  THEN
           message_string = 'boundary condition: bc_sa_t = "' // &
                            TRIM( bc_sa_t ) // '" requires to set ' // &
@@ -1667,5 +1667,5 @@
        ENDIF
 
-       IF ( surface_waterflux == 9999999.9  )  THEN
+       IF ( surface_waterflux == 9999999.9_wp  )  THEN
           constant_waterflux = .FALSE.
           IF ( large_scale_forcing )  THEN
@@ -1817,14 +1817,14 @@
 !-- Set the default intervals for data output, if necessary
 !-- NOTE: dt_dosp has already been set in package_parin
-    IF ( dt_data_output /= 9999999.9 )  THEN
-       IF ( dt_dopr           == 9999999.9 )  dt_dopr           = dt_data_output
-       IF ( dt_dopts          == 9999999.9 )  dt_dopts          = dt_data_output
-       IF ( dt_do2d_xy        == 9999999.9 )  dt_do2d_xy        = dt_data_output
-       IF ( dt_do2d_xz        == 9999999.9 )  dt_do2d_xz        = dt_data_output
-       IF ( dt_do2d_yz        == 9999999.9 )  dt_do2d_yz        = dt_data_output
-       IF ( dt_do3d           == 9999999.9 )  dt_do3d           = dt_data_output
-       IF ( dt_data_output_av == 9999999.9 )  dt_data_output_av = dt_data_output
+    IF ( dt_data_output /= 9999999.9_wp )  THEN
+       IF ( dt_dopr           == 9999999.9_wp )  dt_dopr           = dt_data_output
+       IF ( dt_dopts          == 9999999.9_wp )  dt_dopts          = dt_data_output
+       IF ( dt_do2d_xy        == 9999999.9_wp )  dt_do2d_xy        = dt_data_output
+       IF ( dt_do2d_xz        == 9999999.9_wp )  dt_do2d_xz        = dt_data_output
+       IF ( dt_do2d_yz        == 9999999.9_wp )  dt_do2d_yz        = dt_data_output
+       IF ( dt_do3d           == 9999999.9_wp )  dt_do3d           = dt_data_output
+       IF ( dt_data_output_av == 9999999.9_wp )  dt_data_output_av = dt_data_output
        DO  mid = 1, max_masks
-          IF ( dt_domask(mid) == 9999999.9 )  dt_domask(mid)    = dt_data_output
+          IF ( dt_domask(mid) == 9999999.9_wp )  dt_domask(mid)    = dt_data_output
        ENDDO
     ENDIF
@@ -1832,20 +1832,20 @@
 !
 !-- Set the default skip time intervals for data output, if necessary
-    IF ( skip_time_dopr    == 9999999.9 ) &
+    IF ( skip_time_dopr    == 9999999.9_wp ) &
                                        skip_time_dopr    = skip_time_data_output
-    IF ( skip_time_dosp    == 9999999.9 ) &
+    IF ( skip_time_dosp    == 9999999.9_wp ) &
                                        skip_time_dosp    = skip_time_data_output
-    IF ( skip_time_do2d_xy == 9999999.9 ) &
+    IF ( skip_time_do2d_xy == 9999999.9_wp ) &
                                        skip_time_do2d_xy = skip_time_data_output
-    IF ( skip_time_do2d_xz == 9999999.9 ) &
+    IF ( skip_time_do2d_xz == 9999999.9_wp ) &
                                        skip_time_do2d_xz = skip_time_data_output
-    IF ( skip_time_do2d_yz == 9999999.9 ) &
+    IF ( skip_time_do2d_yz == 9999999.9_wp ) &
                                        skip_time_do2d_yz = skip_time_data_output
-    IF ( skip_time_do3d    == 9999999.9 ) &
+    IF ( skip_time_do3d    == 9999999.9_wp ) &
                                        skip_time_do3d    = skip_time_data_output
-    IF ( skip_time_data_output_av == 9999999.9 ) &
+    IF ( skip_time_data_output_av == 9999999.9_wp ) &
                                 skip_time_data_output_av = skip_time_data_output
     DO  mid = 1, max_masks
-       IF ( skip_time_domask(mid) == 9999999.9 ) &
+       IF ( skip_time_domask(mid) == 9999999.9_wp ) &
                                 skip_time_domask(mid)    = skip_time_data_output
     ENDDO
@@ -1860,5 +1860,5 @@
     ENDIF
 
-    IF ( averaging_interval_pr == 9999999.9 )  THEN
+    IF ( averaging_interval_pr == 9999999.9_wp )  THEN
        averaging_interval_pr = averaging_interval
     ENDIF
@@ -1870,5 +1870,5 @@
     ENDIF
 
-    IF ( averaging_interval_sp == 9999999.9 )  THEN
+    IF ( averaging_interval_sp == 9999999.9_wp )  THEN
        averaging_interval_sp = averaging_interval
     ENDIF
@@ -1882,5 +1882,5 @@
 !
 !-- Set the default interval for profiles entering the temporal average
-    IF ( dt_averaging_input_pr == 9999999.9 )  THEN
+    IF ( dt_averaging_input_pr == 9999999.9_wp )  THEN
        dt_averaging_input_pr = dt_averaging_input
     ENDIF
@@ -1889,5 +1889,5 @@
 !-- Set the default interval for the output of timeseries to a reasonable
 !-- value (tries to minimize the number of calls of flow_statistics)
-    IF ( dt_dots == 9999999.9 )  THEN
+    IF ( dt_dots == 9999999.9_wp )  THEN
        IF ( averaging_interval_pr == 0.0 )  THEN
           dt_dots = MIN( dt_run_control, dt_dopr )
@@ -1916,5 +1916,5 @@
 !-- Set the default value for the integration interval of precipitation amount
     IF ( precipitation )  THEN
-       IF ( precipitation_amount_interval == 9999999.9 )  THEN
+       IF ( precipitation_amount_interval == 9999999.9_wp )  THEN
           precipitation_amount_interval = dt_do2d_xy
        ELSE
@@ -3277,5 +3277,5 @@
 !
 !-- Determine upper and lower hight level indices for random perturbations
-    IF ( disturbance_level_b == -9999999.9 )  THEN
+    IF ( disturbance_level_b == -9999999.9_wp )  THEN
        IF ( ocean ) THEN
           disturbance_level_b     = zu((nzt*2)/3)
@@ -3302,5 +3302,5 @@
     ENDIF
 
-    IF ( disturbance_level_t == -9999999.9 )  THEN
+    IF ( disturbance_level_t == -9999999.9_wp )  THEN
        IF ( ocean )  THEN
           disturbance_level_t     = zu(nzt-3)
@@ -3419,5 +3419,5 @@
 !-- In case of turbulent inflow calculate the index of the recycling plane
     IF ( turbulent_inflow )  THEN
-       IF ( recycling_width == 9999999.9 )  THEN
+       IF ( recycling_width == 9999999.9_wp )  THEN
 !
 !--       Set the default value for the width of the recycling domain
@@ -3482,5 +3482,5 @@
 !-- Set time for the next user defined restart (time_restart is the
 !-- internal parameter for steering restart events)
-    IF ( restart_time /= 9999999.9 )  THEN
+    IF ( restart_time /= 9999999.9_wp )  THEN
        IF ( restart_time > time_since_reference_point )  THEN
           time_restart = restart_time
@@ -3490,5 +3490,5 @@
 !--    In case of a restart run, set internal parameter to default (no restart)
 !--    if the NAMELIST-parameter restart_time is omitted
-       time_restart = 9999999.9
+       time_restart = 9999999.9_wp
     ENDIF
 
Index: /palm/trunk/SOURCE/cpulog.f90
===================================================================
--- /palm/trunk/SOURCE/cpulog.f90	(revision 1321)
+++ /palm/trunk/SOURCE/cpulog.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL functions provided with KIND-attribute
 !
 ! Former revisions:
@@ -165,7 +165,7 @@
 #if defined( __lc ) || defined( __decalpha ) || defined( __nec )
        CALL SYSTEM_CLOCK( count, count_rate )
-       mtime = REAL( count ) / REAL( count_rate )
+       mtime = REAL( count, KIND=wp ) / REAL( count_rate, KIND=wp )
 #elif defined( __ibm )
-       mtime = IRTC( ) * 1E-9
+       mtime = IRTC( ) * 1E-9_wp
 #else
        message_string = 'no time measurement defined on this host'
@@ -322,6 +322,6 @@
 !--       Get total time in order to calculate CPU-time per gridpoint and timestep
           IF ( nr_timesteps_this_run /= 0 )  THEN
-             average_cputime = log_point(1)%sum / REAL( (nx+1) * (ny+1) * nz ) / &
-                               REAL( nr_timesteps_this_run ) * 1E6  ! in micro-sec
+             average_cputime = log_point(1)%sum / REAL( (nx+1) * (ny+1) * nz, KIND=wp ) / &
+                               REAL( nr_timesteps_this_run, KIND=wp ) * 1E6_wp  ! in micro-sec
           ELSE
              average_cputime = -1.0
Index: /palm/trunk/SOURCE/data_output_profiles.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_profiles.f90	(revision 1321)
+++ /palm/trunk/SOURCE/data_output_profiles.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL functions provided with KIND-attribute
 !
 ! Former revisions:
@@ -102,5 +102,5 @@
     ELSE
        IF ( average_count_pr > 0 )  THEN
-          hom_sum = hom_sum / REAL( average_count_pr )
+          hom_sum = hom_sum / REAL( average_count_pr, KIND=wp )
        ELSE
 !
Index: /palm/trunk/SOURCE/data_output_spectra.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_spectra.f90	(revision 1321)
+++ /palm/trunk/SOURCE/data_output_spectra.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL functions provided with KIND-attribute
 !
 ! Former revisions:
@@ -113,6 +113,6 @@
        ENDIF
        IF ( average_count_sp /= 1 )  THEN
-          spectrum_x = spectrum_x / REAL( average_count_sp )
-          spectrum_y = spectrum_y / REAL( average_count_sp )
+          spectrum_x = spectrum_x / REAL( average_count_sp, KIND=wp )
+          spectrum_y = spectrum_y / REAL( average_count_sp, KIND=wp )
           average_count_sp = 0
        ENDIF
Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 1321)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -132,11 +132,11 @@
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
-                kmxp = 0.25 * &
+                kmxp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-                kmxm = 0.25 * &
+                kmxm = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-                kmyp = 0.25 * &
+                kmyp = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-                kmym = 0.25 * &
+                kmym = 0.25_wp *                                               &
                        ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
@@ -152,5 +152,5 @@
                       &   - kmym * ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)     &
                       &   ) * ddy                                              &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
@@ -165,11 +165,11 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmxp = 0.25 * &
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-                   kmyp = 0.25 * &
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-                   kmym = 0.25 * &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
@@ -262,11 +262,11 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmxp = 0.25 * &
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-                   kmyp = 0.25 * &
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-                   kmym = 0.25 * &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
@@ -282,5 +282,5 @@
                          &   - kmym * ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)    &
                          &   ) * ddy                                             &
-                         & + 2.0 * (                                             &
+                         & + 2.0_wp * (                                          &
                          &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
                          & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
@@ -297,11 +297,11 @@
 !
 !--                Interpolate eddy diffusivities on staggered gridpoints
-                   kmxp = 0.25 * &
+                   kmxp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-                   kmxm = 0.25 * &
+                   kmxm = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-                   kmyp = 0.25 * &
+                   kmyp = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-                   kmym = 0.25 * &
+                   kmym = 0.25_wp *                                            &
                           ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
@@ -378,8 +378,8 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmxp = 0.25 * ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-          kmxm = 0.25 * ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-          kmyp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-          kmym = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+          kmxp = 0.25_wp * ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
+          kmxm = 0.25_wp * ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
+          kmyp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
+          kmym = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
@@ -394,5 +394,5 @@
                       &   - kmym * ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)     &
                       &   ) * ddy                                              &
-                      & + 2.0 * (                                              &
+                      & + 2.0_wp * (                                           &
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
@@ -423,8 +423,8 @@
 !
 !--          Interpolate eddy diffusivities on staggered gridpoints
-             kmxp = 0.25 * ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
-             kmxm = 0.25 * ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
-             kmyp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
-             kmym = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+             kmxp = 0.25_wp * ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
+             kmxm = 0.25_wp * ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
+             kmyp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
+             kmym = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
 
              tend(k,j,i) = tend(k,j,i)                                         &
Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 1321)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants defined as wp-kind 
 !
 ! Former revisions:
@@ -141,9 +141,9 @@
                 IF ( dvar_dz > 0.0 ) THEN
                    IF ( use_single_reference_value )  THEN
-                      l_stable = 0.76 * sqrt_e /                               &
-                                 SQRT( g / var_reference * dvar_dz ) + 1E-5
+                      l_stable = 0.76_wp * sqrt_e /                            &
+                                 SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
                    ELSE
-                      l_stable = 0.76 * sqrt_e /                               &
-                                 SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                      l_stable = 0.76_wp * sqrt_e /                            &
+                                 SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
                    ENDIF
                 ELSE
@@ -162,6 +162,6 @@
       !
       !--       Compute diffusion coefficients for momentum and heat
-                km(k,j,i) = 0.1 * l * sqrt_e
-                kh(k,j,i) = ( 1.0 + 2.0 * l / ll ) * km(k,j,i)
+                km(k,j,i) = 0.1_wp * l * sqrt_e
+                kh(k,j,i) = ( 1.0_wp + 2.0_wp * l / ll ) * km(k,j,i)
 
              ENDIF
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 1321)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -98,6 +98,6 @@
           DO  j = dist_nys(dist_range), dist_nyn(dist_range)
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
-                randomnumber = 3.0 * disturbance_amplitude *                   &
-                               ( random_function( iran ) - 0.5 )
+                randomnumber = 3.0_wp * disturbance_amplitude *                &
+                               ( random_function( iran ) - 0.5_wp )
                 IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.         &
                      nyn >= j )                                                &
@@ -113,10 +113,10 @@
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
 #if defined( __nec )
-                randomnumber = 3.0 * disturbance_amplitude *                   &
-                               ( RANDOM( 0 ) - 0.5 )
+                randomnumber = 3.0_wp * disturbance_amplitude *                &
+                               ( RANDOM( 0 ) - 0.5_wp )
 #else
                 CALL RANDOM_NUMBER( randomnumber )
-                randomnumber = 3.0 * disturbance_amplitude *                   &
-                                ( randomnumber - 0.5 )
+                randomnumber = 3.0_wp * disturbance_amplitude *                &
+                                ( randomnumber - 0.5_wp )
 #endif
                 IF ( nxl <= i .AND. nxr >= i .AND. nys <= j .AND. nyn >= j )   &
@@ -145,10 +145,10 @@
              dist2(k,j,i) = ( dist1(k,j,i-1) + dist1(k,j,i+1)                  &
                             + dist1(k,j+1,i) + dist1(k+1,j,i)                  &
-                            ) / 12.0
+                            ) / 12.0_wp
           ENDDO
           DO  k = disturbance_level_ind_b-1, disturbance_level_ind_t+1
               dist2(k,j,i) = dist2(k,j,i) + ( dist1(k,j-1,i) + dist1(k-1,j,i)  &
-                            + 6.0 * dist1(k,j,i)                               &
-                            ) / 12.0
+                            + 6.0_wp * dist1(k,j,i)                            &
+                            ) / 12.0_wp
           ENDDO
         ENDDO
@@ -165,6 +165,6 @@
              dist1(k,j,i) = ( dist2(k,j,i-1) + dist2(k,j,i+1) + dist2(k,j-1,i) &
                             + dist2(k,j+1,i) + dist2(k+1,j,i) + dist2(k-1,j,i) &
-                            + 6.0 * dist2(k,j,i)                               &
-                            ) / 12.0
+                            + 6.0_wp * dist2(k,j,i)                            &
+                            ) / 12.0_wp
           ENDDO
        ENDDO
Index: /palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 1321)
+++ /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 1322)
@@ -19,6 +19,6 @@
 !
 ! Current revisions:
-! -----------------
-! 
+! ------------------
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -79,5 +79,5 @@
     DO  i = 0, nx
        DO  j = 0, ny
-          randomnumber = random_gauss( iran, 5.0 )
+          randomnumber = random_gauss( iran, 5.0_wp )
           IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j )   &
           THEN
Index: /palm/trunk/SOURCE/fft_xy.f90
===================================================================
--- /palm/trunk/SOURCE/fft_xy.f90	(revision 1321)
+++ /palm/trunk/SOURCE/fft_xy.f90	(revision 1322)
@@ -16,9 +16,9 @@
 !
 ! Copyright 1997-2014 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! REAL functions provided with KIND-attribute
 !
 ! Former revisions:
@@ -413,5 +413,5 @@
 
                    DO  i = 0, (nx+1)/2
-                      ar(i,j,k) = REAL( cwork(i) )
+                      ar(i,j,k) = REAL( cwork(i), KIND=wp )
                    ENDDO
                    DO  i = 1, (nx+1)/2 - 1
@@ -441,5 +441,5 @@
 
                    DO  i = 0, nx
-                      ar(i,j,k) = REAL( cwork(i) )
+                      ar(i,j,k) = REAL( cwork(i), KIND=wp )
                    ENDDO
 
@@ -519,5 +519,5 @@
 
                       DO  i = 0, (nx+1)/2
-                         ar_2d(i,j) = REAL( x_out(i) ) / ( nx+1 )
+                         ar_2d(i,j) = REAL( x_out(i), KIND=wp ) / ( nx+1 )
                       ENDDO
                       DO  i = 1, (nx+1)/2 - 1
@@ -528,5 +528,5 @@
 
                       DO  i = 0, (nx+1)/2
-                         ar(i,j,k) = REAL( x_out(i) ) / ( nx+1 )
+                         ar(i,j,k) = REAL( x_out(i), KIND=wp ) / ( nx+1 )
                       ENDDO
                       DO  i = 1, (nx+1)/2 - 1
@@ -689,5 +689,5 @@
 
                    DO  i = 0, (nx+1)/2
-                      ar(i,j,k)      = REAL( ar_tmp(i,j,k) )  * dnx
+                      ar(i,j,k)      = REAL( ar_tmp(i,j,k), KIND=wp )  * dnx
                    ENDDO
 
@@ -794,5 +794,5 @@
              CALL FFTN( cwork, ishape )
              DO  i = 0, (nx+1)/2
-                ar(i) = REAL( cwork(i) )
+                ar(i) = REAL( cwork(i), KIND=wp )
              ENDDO
              DO  i = 1, (nx+1)/2 - 1
@@ -813,5 +813,5 @@
 
              DO  i = 0, nx
-                ar(i) = REAL( cwork(i) )
+                ar(i) = REAL( cwork(i), KIND=wp )
              ENDDO
 
@@ -862,5 +862,5 @@
 
              DO  i = 0, (nx+1)/2
-                ar(i) = REAL( x_out(i) ) / ( nx+1 )
+                ar(i) = REAL( x_out(i), KIND=wp ) / ( nx+1 )
              ENDDO
              DO  i = 1, (nx+1)/2 - 1
@@ -1056,5 +1056,5 @@
 
                    DO  j = 0, (ny+1)/2
-                      ar_tr(j,i,k) = REAL( cwork(j) )
+                      ar_tr(j,i,k) = REAL( cwork(j), KIND=wp )
                    ENDDO
                    DO  j = 1, (ny+1)/2 - 1
@@ -1084,5 +1084,5 @@
 
                    DO  j = 0, ny
-                      ar(j,i,k) = REAL( cwork(j) )
+                      ar(j,i,k) = REAL( cwork(j), KIND=wp )
                    ENDDO
 
@@ -1160,5 +1160,5 @@
 
                    DO  j = 0, (ny+1)/2
-                      ar_tr(j,i,k) = REAL( y_out(j) ) / (ny+1)
+                      ar_tr(j,i,k) = REAL( y_out(j), KIND=wp ) / (ny+1)
                    ENDDO
                    DO  j = 1, (ny+1)/2 - 1
@@ -1305,5 +1305,5 @@
 
                    DO  j = 0, (ny+1)/2
-                      ar(j,i,k)      = REAL( ar_tmp(j,i,k) )  * dny
+                      ar(j,i,k)      = REAL( ar_tmp(j,i,k), KIND=wp )  * dny
                    ENDDO
 
@@ -1412,5 +1412,5 @@
 
              DO  j = 0, (ny+1)/2
-                ar(j) = REAL( cwork(j) )
+                ar(j) = REAL( cwork(j), KIND=wp )
              ENDDO
              DO  j = 1, (ny+1)/2 - 1
@@ -1431,5 +1431,5 @@
 
              DO  j = 0, ny
-                ar(j) = REAL( cwork(j) )
+                ar(j) = REAL( cwork(j), KIND=wp )
              ENDDO
 
@@ -1480,5 +1480,5 @@
 
              DO  j = 0, (ny+1)/2
-                ar(j) = REAL( y_out(j) ) / (ny+1)
+                ar(j) = REAL( y_out(j), KIND=wp ) / (ny+1)
              ENDDO
              DO  j = 1, (ny+1)/2 - 1
@@ -1674,5 +1674,5 @@
              DO  k = 1, nz
                 DO  i = 0, (nx+1)/2
-                   ar(i,k) = REAL( work(i+1,k) )
+                   ar(i,k) = REAL( work(i+1,k), KIND=wp )
                 ENDDO
                 DO  i = 1, (nx+1)/2 - 1
@@ -1817,5 +1817,5 @@
              DO  k = 1, nz
                 DO  j = 0, (ny+1)/2
-                   ar(j,k) = REAL( work(j+1,k) )
+                   ar(j,k) = REAL( work(j+1,k), KIND=wp )
                 ENDDO
                 DO  j = 1, (ny+1)/2 - 1
